/**
 * Created with AppCode.
 * User: yop
 * Date: 15/9/3
 * Time: 下午8:03
 * To change this template use File | Settings | File Templates.
 */

var BtnShop = vee.Class.extend({
	spHead : null,
	spBtnR : null,
	btnOpenStore : null,
	onCreate : function () {
		BtnShop.instance = this;
		this.refreshBtnHead();
		vee.Controller.registerControllerSprite(this.spBtnR);
	},

	onExit : function () {
		BtnShop.instance = null;
		vee.Controller.removeControllerSprite(this.spBtnR);
	},

	refreshBtnHead : function () {
		var avatar = game.AvatarData.getCurrentAvatar();
		this.spHead.setTexture(avatar.headName);
	},

	onOpenStore : function() {
		if (LyLevelSelect.isUnlocking) return;
		if (LyAvatarStore.getInstance()) {
			LyAvatarStore.getInstance().show();
		}
	}
});

BtnShop.instance = null;
BtnShop.refreshHead = function () {
	if (BtnShop.instance) {
		BtnShop.instance.refreshBtnHead();
	}
};

var LyAvatarStore = vee.Class.extend({
	/** @type {vee.PagingController} */
	pagingCtl : null,

//	lbCoinNum : null,

	btnClose      : null,
	btnBuyAll     : null,
	btnRestore    : null,
	containerNode : null,
	lbPrice       : null,
	lbRestore     : null,
	ccbBuyAvatar  : null,

	ccbBuyItem1 : null,
	ccbBuyItem2 : null,
	ccbBuyItem3 : null,
	ccbBuyItem4 : null,

	onLoaded : function() {
		LyAvatarStore.instance = this;
		var num = this.lyContent.getChildrenCount();
		var ctl = vee.PowerPagingController.registerController(this.lyContent, num);
		ctl.setSensitivity(0.75);
		ctl.setBounceEnabled(true);
		ctl.setPageChanged(this.onPageChanged.bind(this));
		ctl.setDragingBuffer(30);
		ctl.setEnabled(false);
		this.pagingCtl = ctl;

		vee.PopMgr.setNodePos(this.btnClose, vee.PopMgr.PositionType.TopRight, cc.p(0,0));
		this.rootNode.setVisible(false);
		this.rootNode.setLocalZOrder(-1);

		this.refreshCoin();
		this.refreshBuyState();
		this.handleKey(true);
		LyAvatarStore.isShow = false;
	},

	_tempControllerState : null,
	_defaultCursorGrid : null,
	initController : function () {
		vee.Controller.activeButton();
		vee.Controller.registerButtonAction(
			vee.KeyCode.BUTTON_DPAD_LEFT,
			this.pageToLeft.bind(this)
		);
		vee.Controller.registerButtonAction(
			vee.KeyCode.BUTTON_DPAD_RIGHT,
			this.pageToRight.bind(this)
		);
		vee.Controller.registerButtonAction(
			[vee.KeyCode.BUTTON_B,vee.KeyCode.BUTTON_RIGHT_SHOULDER,vee.KeyCode.AXIS_RIGHT_TRIGGER],
			this.hide.bind(this)
		);
		var initGrid = this._defaultCursorGrid ? this._defaultCursorGrid : cc.p(1,0);
		vee.Controller.initSelector(8, 2, null, initGrid);
		if (game.Data.isFreeGame) {
			if (this.btnBuyAll.isVisible()) {
				vee.Controller.registerItemByButton(this.btnBuyAll, cc.p(0,0), this.onBuyAll.bind(this), "res/mfi_btn_on_210.png");
				vee.Controller.registerItemByButton(this.btnRestore, cc.p(0,1), this.onRestore.bind(this), "res/mfi_btn_on_170.png");
			}
		}
		this.createItem();
		vee.Controller.activeSelector();
	},
	pageToLeft : function () {
		var pageGrid = vee.Controller.getSelectorGrid();
		this.pagingCtl.setPage(pageGrid.x + 1, true);
	},
	pageToRight : function () {
		var pageGrid = vee.Controller.getSelectorGrid();
		this.pagingCtl.setPage(pageGrid.x + 1, true);
	},
	createItem : function () {
		for (var i = 1; i < 8; ++i) {
			var ctl = this._getAvatarCellCtl(i*2-1);
			if (ctl) vee.Controller.registerItemByButton(ctl.spBG, cc.p(i,0), ctl.onBuy.bind(ctl), "res/mfi_avatar_on.png", cc.p(-4,0));
			var ctl = this._getAvatarCellCtl(i*2);
			if (ctl) vee.Controller.registerItemByButton(ctl.spBG, cc.p(i,1), ctl.onBuy.bind(ctl), "res/mfi_avatar_on.png", cc.p(-4,0));
		}
	},
	_getAvatarCellCtl : function (idx) {
		var cell = this["avatarCell" + idx];
		if (cell)
			return cell.controller;
		else
			return null;
	},

	onExit : function () {
		LyAvatarStore.instance = null;
		LyAvatarStore.arrCell = [];
	},

	refreshBuyState : function () {
		if (game.Data.isFreeGame && vee.data["allcat"]) {
			this.btnBuyAll.setVisible(false);
			this.btnRestore.setVisible(false);
			this.lbPrice.setVisible(false);
			this.lbRestore.setVisible(false);
			this.ccbBuyAvatar.controller.refreshState();
		}
	},

	onKeyBack : function() {
		this.hide();
		return true;
	},

	refreshCoin : function () {

	},

	onClose : function() {
		this.hide();
	},

	show : function() {
		LyAvatarStore.isShow = true;
		cc.log("avatar show");
		this.pagingCtl.setEnabled(true);
		this.rootNode.setVisible(true);
		this.rootNode.setLocalZOrder(99999); //update Touch
		this.playAnimate('show');
		vee.Audio.playEffect(res.outGame_menu_intoStore_mp3);

		this._tempControllerState = vee.Controller.cacheControllerState();

		LyAvatarStore.refreshState();  // added by yzl
	},

	hide : function() {
		if (!LyAvatarStore.isShow) return;
		vee.Controller.deactiveSelector();
		vee.Controller.deactiveButton();
		if (vee.Controller._cursorGrid) {
			this._defaultCursorGrid = cc.p(vee.Controller._cursorGrid.x, vee.Controller._cursorGrid.y);
		}

		this.pagingCtl.setEnabled(false);
		this.playAnimate('hide', function() {
			LyAvatarStore.isShow = false;
			this.rootNode.setVisible(false);
			this.rootNode.setLocalZOrder(-1); //update Touch

			vee.Controller.reviveControllerState(this._tempControllerState);
		}.bind(this));
		vee.Audio.playEffect(res.outGame_menu_closeStore_mp3);
	},

	onPageChanged : function(pageNum) {

	},

	onBuyAll : function () {
		/*
		if (!this.btnBuyAll.isVisible()) return;
		vee.IAPMgr.buyProduct(1, function () {
			game.AvatarData.allPurchase();
			this.refreshBuyState();
			cc.log("state : "+vee.Controller._isActiveSelector+" "+vee.Controller._isActiveButton);
			vee.Controller.activeButton();
			vee.Controller.activeSelector();
			vee.Utils.scheduleOnce(function () {
				vee.PopMgr.alert(
					vee.Utils.getLocalizedStringForKey("All avatar has been unlocked"),
					vee.Utils.getLocalizedStringForKey("SUCCESS")
				);
			}, 0.2);
			vee.Analytics.logChargeSuccess(game.Data.orderId);
		}.bind(this), function () {

		});
		game.Data.orderId = new Date().getTime();
		vee.Analytics.logChargeRequest(game.Data.orderId, 1, 1.99);
		*/
	},

	onRestore : function () {
		if (!this.btnRestore.isVisible()) return;
		vee.IAPMgr.restoreProduct(function (productID) {
			cc.log("pd id = "+productID);
			var ids = productID.split(",");
			for (id in ids) {
				var pdid = ids[id];
				if (pdid == "com.veewo.allcat") {
					game.AvatarData.allPurchase();
					this.refreshBuyState();
					vee.Controller.activeButton();
					vee.Controller.activeSelector();
					vee.Utils.scheduleOnce(function () {
						vee.PopMgr.alert(
							vee.Utils.getLocalizedStringForKey("All avatar has been unlocked"),
							vee.Utils.getLocalizedStringForKey("SUCCESS")
						);
					}, 0.2);
				}
			}
		}.bind(this));
	}
});

LyAvatarStore.instance = null;
LyAvatarStore.getInstance = function () {
	return LyAvatarStore.instance;
};
LyAvatarStore.arrCell = [];
LyAvatarStore.arrShop = [];
LyAvatarStore.refreshState = function () {
	if (LyAvatarStore.instance) {
		for (var i in LyAvatarStore.arrCell) {
			var cell = LyAvatarStore.arrCell[i];
			cell.refreshCellState();
		}

		for (var i in LyAvatarStore.arrShop) {
			var cell = LyAvatarStore.arrShop[i];
			cell.refreshState();
		}
	}
};

LyAvatarStore.isShow = false;

LyAvatarStore.load = function () {
	var node = null;
	if (game.Data.isFreeGame) {
		node = cc.BuilderReader.load(res.lyAvatarStore_android_ccbi);
	} else {
		node = cc.BuilderReader.load(res.lyAvatarStore_ccbi);
	}
	return node;
};

var BuyAvatar = vee.Class.extend({
	spText : null,

	onCreate : function () {
		this.refreshState();
	},

	refreshState : function () {
		if (vee.data["allcat"]) {
			this.spText.setVisible(false);
		}
	}
});



var ShopCell = vee.Class.extend({

	/** @type {cc.Label} */
	lbPrice : null,
	/** @type {cc.Label} */
	lbDesc : null,
	/** @type {cc.ControlButton} */
	btnBuy : null,

	spItem : null,

	idx : 0,


	onCreate : function () {
		this.idx = this.rootNode.getTag();
		// set ItemData
		var itemDetail = game.ItemData.ItemDetail[this.idx];
		this.lbPrice.setString(itemDetail.priceDesc);
		this.lbDesc.setString(itemDetail.desc);
		this.spItem.setTexture(itemDetail.picName);

		if (this.idx>5 && this.idx<10) {
			LyAvatarStore.arrShop[this.idx] = this;
		}
		// end set
		this.refreshState();
	},

	refreshState : function () {
		if (this.idx == 1) {
			if (game.Data.getEnergy() < 5) {
				this.playAnimate('coin');
				//if (vee.Ad._videoAdEnable) {
					//this.lbPrice.setString("看广告");
				//}
				//else {
					this.lbPrice.setString(game.ItemData.ItemDetail[this.idx].priceDesc);
				//}
			}
			else {
				this.playAnimate('owned');
			}
			return;
		}
		
		if (this.idx == 2) {
			if (game.Data.getEnergy() < 5) {
				this.playAnimate('coin');
			}
			else {
				this.playAnimate('owned');
			}
			return;
		}
		
		if (game.ItemData.getItemPurchased(this.idx)) {
			this.playAnimate('selected');
		}
		else {
			this.playAnimate('coin');
		}
	},

	onBuy : function() {
		var ItemIdx = this.idx;

		if (ItemIdx == 1 || ItemIdx == 2) {
			if (game.Data.getEnergy() >= 5)
				return;
		}

		/*  看广告不再有体力
		if (ItemIdx == 1 && vee.Ad._videoAdEnable) {
			vee.Ad.showVideoAd(
				function() {
					game.Data.addEnergy(1);
					if (game.Data.oEnergyCtl) game.Data.oEnergyCtl.showEnergy();
					this.refreshState();
				}.bind(this)
			)
			return;
		}
		*/

		vee.IAPMgr.buyProduct(ItemIdx,
			function () {
				game.ItemData.BuyItemDone(ItemIdx);
				this.refreshState();
			}.bind(this),
			function () {
				vee.alert(
					vee.Utils.getLocalizedStringForKey("Purchase Failed"),
					vee.Utils.getLocalizedStringForKey("There is something wrong in purchase")
				);
			}
		);
	},
});




// added by yzl

game.CISData = {

	numCoinMultiple : 1,
	numExtraLife : 0,

	isPurchased : false,

	adWin : 0.75,
	adLose : 0.75,

	initCISData : function() {
		var extraLife = vee.VIPValues.getValue('ExtraLife');
		if (extraLife) {
			this.numExtraLife = extraLife;
		}

		var coinMultiple = vee.VIPValues.getValue('CoinMultiple');
		if (coinMultiple) {
			this.numCoinMultiple = coinMultiple;
		}

		var itemData = vee.VIPValues.getValue('ItemData');
		if (itemData && itemData>0) {
			this.isPurchased = true;
		}

		var star = game.LevelData.getStar();
		for (var i = 1; i <= 10; i++) {
			if (game.LeaderData.LeaderDetail[i].starNum <= star) {
				LyLeaderBoard.curIndex = i;
				LyLeaderBoard.newIndex = i;
				break;
			}
		}

		var adW = vee.data["adwin"];
		var adL = vee.data["adlose"];
		this.adWin = adW ? parseInt(adW) * 0.01 : 1;
		this.adLose = adL ? parseInt(adL) * 0.01 : 1;
	},

	playAdByConfig : function(config) {
		if (this.isPurchased)
			return false;

		var r = Math.random();
		if (r < config) {
			vee.Ad.showVideoAd(
				function() {
					vee.Analytics.logEvent("ad_show_mi");
				}.bind(this)
			);

			return true;
		}

		return false;
	},
};







game.ItemData = {

	// price 以分为单位
	ItemDetail : [
		{ idx : 0, 	picName : "",					desc : "", 	priceDesc : '--',    	price : 100,	},
		{ idx : 1, 	picName : res.mi_item_power_1,		desc : "补充体力", 	priceDesc : "1元",	price : 100,	},
		{ idx : 2, 	picName : res.mi_item_power_5,		desc : "体力回满", 	priceDesc : "3元", 	price : 300,	},
		{ idx : 3, 	picName : res.mi_item_powDrink_1,	desc : "体力药剂", 	priceDesc : "3元",	price : 300,	},
		{ idx : 4, 	picName : res.mi_item_powDrink_3,	desc : "体力药剂", 	priceDesc : "5元",	price : 500,	},
		{ idx : 5, 	picName : res.mi_item_powInfinite,	desc : "无限体力", 	priceDesc : "8元",	price : 800,	},
		{ idx : 6, 	picName : res.mi_item_coin_100,	desc : "金币获取", 	priceDesc : "10元",   price : 1000,	},
		{ idx : 7, 	picName : res.mi_item_coin_200,	desc : "金币获取", 	priceDesc : "15元",   price : 1500,	},
		{ idx : 8, 	picName : res.mi_item_life_1,	desc : "额外生命", 	priceDesc : "6元",    price : 600,	},
		{ idx : 9, 	picName : res.mi_item_life_2,	desc : "额外生命", 	priceDesc : "10元",   price : 1000,	},
		{ idx : 10,	picName : "",					desc : "", 	priceDesc : "2元",     	price : 200,	},
		{ idx : 11,	picName : "",					desc : "", 	priceDesc : "2元",     	price : 200,	},
		{ idx : 12,	picName : "",					desc : "", 	priceDesc : "3元",     	price : 300,	},
		{ idx : 13,	picName : "",					desc : "", 	priceDesc : "6元",     	price : 600,	},
		{ idx : 14,	picName : "",					desc : "", 	priceDesc : "10元",    	price : 1000,	},
		{ idx : 15,	picName : "",					desc : "", 	priceDesc : "3元",     	price : 300,	},
		{ idx : 16,	picName : "",					desc : "", 	priceDesc : "8元",     	price : 800,	},
		{ idx : 17,	picName : "",					desc : "", 	priceDesc : "8元",     	price : 800,	},
		{ idx : 18,	picName : "",					desc : "", 	priceDesc : "6元",     	price : 600,	},
		{ idx : 19,	picName : "",					desc : "", 	priceDesc : "3元",     	price : 300,	},
		{ idx : 20,	picName : "",					desc : "", 	priceDesc : "10元",    	price : 1000,	},
		{ idx : 21,	picName : "",					desc : "", 	priceDesc : "6元",     	price : 600,	},
		{ idx : 22,	picName : "",					desc : "", 	priceDesc : "6元",     	price : 600,	},
		{ idx : 23,	picName : "",					desc : "", 	priceDesc : "3元",     	price : 300,	},
		{ idx : 24,	picName : "",					desc : "", 	priceDesc : "5元",     	price : 500,	},
		{ idx : 25,	picName : "",					desc : "", 	priceDesc : "5元",     	price : 500,	},
		{ idx : 26,	picName : "",					desc : "", 	priceDesc : "1元",     	price : 100,	},
		{ idx : 27,	picName : "",					desc : "", 	priceDesc : "1元",     	price : 100,	},
		{ idx : 28,	picName : "",					desc : "", 	priceDesc : "1元",     	price : 100,	},
		{ idx : 29,	picName : "",					desc : "", 	priceDesc : "1元",     	price : 100,	},
		{ idx : 30,	picName : "",					desc : "新手礼包",    priceDesc : "5元",  price : 500,	},
		{ idx : 31,	picName : "",					desc : "解锁月世界",  priceDesc : "6元",  price : 600,	},
	],

	CheckNewbeeGift : function() {
		return game.ItemData.getItemPurchased(6)
			|| game.ItemData.getItemPurchased(8)
			|| game.ItemData.getItemPurchased(23);
	},

	BuyItemDone : function(idx) {
		if (idx > 4) {
			if (this.getItemPurchased(idx)) return;  // item after 4 can only buy once
		}
		
		switch (idx)
		{
			case 0:
				this.buyItem0();
				break;
			case 1:
				this.buyItem1();
				break;
			case 2:
				this.buyItem2();
				break;
			case 3:
				this.buyItem3();
				break;
			case 4:
				this.buyItem4();
				break;
			case 5:
				this.buyItem5();
				break;
			case 6:
				this.buyItem6();
				break;
			case 7:
				this.buyItem7();
				break;
			case 8:
				this.buyItem8();
				break;
			case 9:
				this.buyItem9();
				break;
			case 10:
				this.buyItem10();
				break;
			case 11:
				this.buyItem11();
				break;
			case 12:
				this.buyItem12();
				break;
			case 13:
				this.buyItem13();
				break;
			case 14:
				this.buyItem14();
				break;
			case 15:
				this.buyItem15();
				break;
			case 16:
				this.buyItem16();
				break;
			case 17:
				this.buyItem17();
				break;
			case 18:
				this.buyItem18();
				break;
			case 19:
				this.buyItem19();
				break;
			case 20:
				this.buyItem20();
				break;
			case 21:
				this.buyItem21();
				break;
			case 22:
				this.buyItem22();
				break;
			case 23:
				this.buyItem23();
				break;
			case 24:
				this.buyItem24();
				break;
			case 25:
				this.buyItem25();
				break;
			case 26:
				this.buyItem26();
				break;
			case 27:
				this.buyItem27();
				break;
			case 28:
				this.buyItem28();
				break;
			case 29:
				this.buyItem29();
				break;
			case 30:
				this.buyItem30();
				break;
			case 31:
				this.buyItem31();
				break;
		}
		
		if (idx > 4) {
			this.setItemPurchased(idx);
		}
	},

	getItemPurchased : function (idx) {
		var itemData = vee.VIPValues.getValue('ItemData');
		if (!itemData)
			return false;

		return itemData & (1 << idx);
	},

	setItemPurchased : function (idx) {
		var itemData = vee.VIPValues.getValue('ItemData');
		if (!itemData) itemData = 0;

		itemData = itemData | (1 << idx);
		vee.VIPValues.setValue('ItemData', itemData);
	},

	buyItem0 : function(){

	},

	buyItem1 : function () {
		game.Data.addEnergy(1);
		if (game.Data.oEnergyCtl) game.Data.oEnergyCtl.showEnergy();
	},

	buyItem2 : function () {
		game.Data.fillEnergy();
		if (game.Data.oEnergyCtl) game.Data.oEnergyCtl.showEnergy();
	},

	buyItem3 : function () {
		vee.dataManager.setPower(vee.dataManager.getPower() + 1);
		if (game.Data.oEnergyCtl) game.Data.oEnergyCtl.showEnergy();
		//AlertUsePower.show(game.LifeEmptyType.Select);
	},

	buyItem4 : function () {
		vee.dataManager.setPower(vee.dataManager.getPower() + 3);
		if (game.Data.oEnergyCtl) game.Data.oEnergyCtl.showEnergy();
		//AlertUsePower.show(game.LifeEmptyType.Select);
	},

	buyItem5 : function () {
		vee.VIPValues.setValue("InfiniteEnergy", 1);
		if (game.Data.oEnergyCtl) game.Data.oEnergyCtl.infiniteEnergy();
		AlertGetPower.hide();
	},

	buyItem6 : function() {
		var coinMultiple = vee.VIPValues.getValue('CoinMultiple');
		if (!coinMultiple) coinMultiple = 1;
		coinMultiple += 1;
		vee.VIPValues.setValue('CoinMultiple', coinMultiple);
		game.CISData.numCoinMultiple = coinMultiple;
	},

	buyItem7 : function() {
		var coinMultiple = vee.VIPValues.getValue('CoinMultiple');
		if (!coinMultiple) coinMultiple = 1;
		coinMultiple += 2;
		vee.VIPValues.setValue('CoinMultiple', coinMultiple);
		game.CISData.numCoinMultiple = coinMultiple;
	},

	buyItem8 : function(){
		var extraLife = vee.VIPValues.getValue('ExtraLife');
		if (!extraLife) extraLife = 0;
		extraLife += 1;
		vee.VIPValues.setValue('ExtraLife', extraLife);
		game.CISData.numExtraLife = extraLife;
	},

	buyItem9 : function(){
		var extraLife = vee.VIPValues.getValue('ExtraLife');
		if (!extraLife) extraLife = 0;
		extraLife += 2;
		vee.VIPValues.setValue('ExtraLife', extraLife);
		game.CISData.numExtraLife = extraLife;
	},

	buyItem10 : function(){
		// unlock chapter 3
		if (game.Data.oLvSelectCtl) {
			game.Data.oLvSelectCtl.unlockCategoryByIdx(3);
		}
	},

	buyItem11 : function(){
		// unlock chapter 4
		if (game.Data.oLvSelectCtl) {
			game.Data.oLvSelectCtl.unlockCategoryByIdx(4);
		}
	},

	buyItem12 : function(){
		if (game.Data.oLvSelectCtl) {
			game.Data.oLvSelectCtl.unlockCategoryByIdx(5);
		}
		// unlock chapter 5
	},

	buyItem13 : function(){
		if (game.Data.oLvSelectCtl) {
			game.Data.oLvSelectCtl.unlockCategoryByIdx(6);
		}
		// unlock chapter 6
	},

	buyItem14 : function(){
		game.AvatarData.avatarPurchased(2); // 月月
	},

	buyItem15 : function(){
		game.AvatarData.avatarPurchased(3); // 小小
	},

	buyItem16 : function(){
		game.AvatarData.avatarPurchased(4); // 安卓
	},

	buyItem17 : function(){
		game.AvatarData.avatarPurchased(5); // 警察
	},

	buyItem18 : function(){
		game.AvatarData.avatarPurchased(6); // 太空侠
	},

	buyItem19 : function(){
		game.AvatarData.avatarPurchased(7); // 恐怖熊
	},

	buyItem20 : function(){
		game.AvatarData.avatarPurchased(8); // 伯爵
	},

	buyItem21 : function(){
		game.AvatarData.avatarPurchased(9); // 电眼
	},

	buyItem22 : function(){
		game.AvatarData.avatarPurchased(10); // 小明
	},

	buyItem23 : function(){
		game.AvatarData.avatarPurchased(11); // 狐狸
	},

	buyItem24 : function(){
		game.AvatarData.avatarPurchased(12); // 兔子
	},

	buyItem25 : function(){
		game.AvatarData.avatarPurchased(13); // 石头
	},

	buyItem26 : function(){
	},

	buyItem27 : function(){
	},

	buyItem28 : function(){
	},

	buyItem29 : function(){
	},

	buyItem30 : function(){         // 新手礼包
		this.buyItem6();
		this.setItemPurchased(6);
		this.buyItem8();
		this.setItemPurchased(8);
		this.buyItem18();
		this.setItemPurchased(18);
	},

	buyItem31 : function(){        // 解锁月世界
		vee.data["moon"] = true;
	},
};
