/**
 * Created with AppCode.
 * User: WanThirty
 * Date: 15/11/19
 * Time: 下午1:57
 * To change this template use File | Settings | File Templates.
 */

var LyGoogle = vee.Class.extend({
	btnClose : null,
	btnGift : null,
	btnDownload : null,
	lbContent : null,
	isOver : false,

	ccbInit : function () {
		if (LyGoogle.NoticeString.length < 1) {
			vee.Utils.checkGameBoard();
		}
		this.handleKey(true);
	},

	refreshState : function () {
		if (LyGoogle.NoticeString.length > 1) {
			this.lbContent.setString(LyGoogle.NoticeString);
		}

		this.btnDownload.setVisible(LyGoogle.DownloadUrl.length > 1);
	},

	onKeyBack : function () {
		this.onClose();
		return true;
	},

	onGift : function () {
		LyGetGift.show();
		this.onClose();
	},

	onDownload : function () {
		vee.Utils.openURL(LyGoogle.DownloadUrl);
	},

	onClose : function () {
		if (this.isOver) return;
		this.isOver = true;
		this.playAnimate("hide", function () {
			vee.PopMgr.closeLayerByCtl(this);
			LyGoogle.isShowing = false;
			LyLevelSelect.nWindow = 0;
		}.bind(this));
	}
});

LyGoogle.show = function () {
	if (LyGoogle.isShowing) {
		LyGoogle.refreshState();
		return;
	}

	if (LyLevelSelect.nWindow > 9)
		return;

	var node = vee.PopMgr.popCCB(res.index_GooglePlay_ccbi, {alpha:0});
	node.controller.ccbInit();

	var date = (new Date()).getDate();
	vee.data["last_gift_date"] = date;
	vee.saveData();

	LyGoogle.isShowing = true;
	LyLevelSelect.nWindow = 9;
};

LyGoogle.isShowing = false;
LyGoogle.hasNewNotice = false;
LyGoogle.NoticeString = '';
LyGoogle.Version = 20002;
LyGoogle.DownloadUrl = '';



var LyMi = vee.Class.extend({
	btnClose : null,
	btnBuy : null,
	isOver : false,

	ccbInit : function () {
		this.handleKey(true);
	},

	onKeyBack : function () {
		this.onClose();
		return true;
	},

	onBuy : function () {
		vee.IAPMgr.buyProduct(30,
			function () {
				game.ItemData.BuyItemDone(30);
				this.onClose();
			}.bind(this),
			function () {
				vee.alert(
					vee.Utils.getLocalizedStringForKey("Purchase Failed"),
					vee.Utils.getLocalizedStringForKey("There is something wrong in purchase")
				);
			}.bind(this)
		);
	},

	onClose : function () {
		if (this.isOver) return;
		this.isOver = true;
		this.playAnimate("hide", function () {
			this.isOver = false;
			vee.PopMgr.closeLayerByCtl(this);
			LyLevelSelect.nWindow = 0;
		}.bind(this));
	}
});

LyMi.show = function () {
	if (LyLevelSelect.nWindow > 5)
		return;

	var node = vee.PopMgr.popCCB(res.index_Mi_ccbi, {alpha:0});
	node.controller.ccbInit();

	var date = (new Date()).getDate();
	vee.data["last_gift_date"] = date;
	vee.saveData();

	LyLevelSelect.nWindow = 5;
};



var LyTips = vee.Class.extend({
	lbContent : null,

	ccbInit : function () {
		LyTips.isShowing = true;
		this.playAnimate("show", function() {
			LyTips.isShowing = false;
			vee.PopMgr.closeLayerByCtl(this);
		}.bind(this));
	},

	setTips : function (tips) {
		this.lbContent.setString(tips);
	},
});

LyTips.isShowing = false;

LyTips.show = function () {
	if (LyTips.isShowing)
		return;

	var node = vee.PopMgr.popCCB(res.index_Tips_ccbi, {alpha:0});
	node.controller.ccbInit();
};




var LyGetGift = vee.Class.extend({
	btnClose : null,
	btnClear : null,
	btnDownload : null,

	btnOne : null,
	btnTwo : null,
	btnThree : null,
	btnFour : null,
	btnFive : null,
	btnSix : null,
	btnSeven : null,
	btnEight : null,
	btnNine : null,
	btnZero : null,

	lbCode : null,
	lbTitle : null,

	isOver : false,

	sCode : "",

	ccbInit : function () {
		this.refreshCode();
		this.handleKey(true);
	},

	refreshCode : function() {
		this.lbCode.setString(this.sCode);
	},

	onKeyBack : function () {
		this.onClose();
		return true;
	},

	onOne : function(){
		this.onNumber(1);
	},

	onTwo : function(){
		this.onNumber(2);
	},

	onThree : function(){
		this.onNumber(3);
	},

	onFour : function(){
		this.onNumber(4);
	},

	onFive : function(){
		this.onNumber(5);
	},

	onSix : function(){
		this.onNumber(6);
	},

	onSeven : function(){
		this.onNumber(7);
	},

	onEight : function(){
		this.onNumber(8);
	},

	onNine : function(){
		this.onNumber(9);
	},

	onZero : function(){
		this.onNumber(0);
	},

	onNumber : function (number) {
		if (this.sCode.length >= 12)
			return;
		this.sCode = this.sCode + number;
		this.refreshCode();
	},

	onClear : function () {
		this.sCode = "";
		this.refreshCode();
	},

	onEnsure : function () {
		vee.Utils.GetGiftByCode(this.sCode);
		this.onClose();
	},

	onClose : function () {
		if (this.isOver) return;
		this.isOver = true;
		this.playAnimate("hide", function () {
			vee.PopMgr.closeLayerByCtl(this);
		}.bind(this));
	}
});

LyGetGift.show = function () {
	var node = vee.PopMgr.popCCB(res.index_Get_Gift_ccbi, {alpha:0});
	node.controller.ccbInit();
};
