/**
 * Created with AppCode.
 * User: WanThirty
 * Date: 15/10/28
 * Time: 下午5:34
 * To change this template use File | Settings | File Templates.
 */

var LySpecial = vee.Class.extend({
	lbTitle     : null,
	lbContent   : null,
	lbDetail    : null,

	btnConfirm  : null,
	btnClose    : null,
	btnRewardCoin : null,
	spHead      : null,

	_isOver     : false,
	_tempControllerState : null,

	onCreate : function () {
		game.Data.resetMiniCount();
	},

	ccbInit : function () {
		this.playAnimate("OPEN");
		var frame = null;
		var adata = game.AvatarData.getNextAvatar(0, true);
		if (adata) {
			frame = adata.headName;
		} else {
			var arr = [0,1,2,3,4,5,6,7,8,9];
			var curIdx = game.AvatarData.getCurrentAvatar().idx;
			arr.splice(curIdx, 1);
			adata = game.AvatarData.getAvatarData(vee.Utils.randomChoice(arr));
			frame = adata.headName;
		}
		this.spHead.setTexture(frame);
		this.handleKey(true);
		this._tempControllerState = vee.Controller.cacheControllerState();
	},

	initController : function () {
		vee.Controller.initSelector(1,1, this.onClose.bind(this), cc.p(0,0));
		vee.Controller.registerItemByButton(this.btnConfirm, cc.p(0,0), this.onConfirm.bind(this), "res/mfi_btn_on_210.png");
		vee.Controller.activeSelector();
	},

	onKeyBack : function(){
		this.onClose();
		return true;
	},

	onConfirm : function () {
		if (this._isOver) return;
		this._isOver = true;
		vee.Controller.deactiveSelector();
		game.Data.resetMiniCount();
		cc.log("mini count = "+game.Data.getMiniCount());
		this.playAnimate("HIDE", function () {
			game.Data.oLyGameOver.showMini();
			vee.PopMgr.closeLayer();
		}.bind(this));
	},

	onRewardCoin : function () {

	},

	onClose : function () {
		if (this._isOver) return;
		this._isOver = true;

		vee.Controller.deactiveSelector();
		this.playAnimate("HIDE", function () {
			vee.Controller.reviveControllerState(this._tempControllerState);
			vee.PopMgr.closeLayer();
		});
		game.Data.oLyGameOver.blockButton = false;
	}
});

LySpecial.show = function () {
	var node = vee.PopMgr.popCCB(res.vAlertboxChallenge_ccbi, { alpha : 0 });
	node.controller.ccbInit();
	vee.Audio.playEffect(res.inGame_function_bonusEntrance_mp3);
};


var LeaderCell = vee.Class.extend({

	spHead : null,
	spLight : null,
	lbStarNum : null,
	lbLeader : null,
	lbName : null,

	idx : 0,


	onCreate : function () {
		this.idx = this.rootNode.getTag();
		LyLeaderBoard.Cells[this.idx] = this;
		var Index = 10;
		if (this.idx == LyLeaderBoard.curIndex)
			Index = 10;
		else if (this.idx < LyLeaderBoard.curIndex)
			Index = this.idx;
		else
			Index = this.idx-1;

		var leaderData = game.LeaderData.LeaderDetail[Index];
		this.lbLeader.setString("" + this.idx);
		this.spHead.setTexture(leaderData.picName);
		this.lbName.setString(leaderData.desc);
		this.spLight.setVisible(this.idx == LyLeaderBoard.curIndex);

		if (Index == 10){
			var starNum = game.LevelData.getStar();
			var starString = "";

			if (LyLeaderBoard.oldStar != 0) {
				starNum = LyLeaderBoard.oldStar;
			}

			if(starNum > 99)
				starString = "x" + starNum;
			else
				starString = "x " + starNum;

			this.lbStarNum.setString(starString);
		}
		else if (Index < 3)
			this.lbStarNum.setString("x" + leaderData.starNum);
		else
			this.lbStarNum.setString("x " + leaderData.starNum);
	},

	refreshLeader : function(leader){
		this.lbLeader.setString("" + leader);
	},

	refreshStar : function(starNum) {
		if (starNum > 99)
			this.lbStarNum.setString("x" + starNum);
		else
			this.lbStarNum.setString("x " + starNum);

		this.lbStarNum.runAction(
			cc.sequence(
				cc.scaleTo(0.25, 1.5),
				cc.scaleTo(0.25, 1.0)
			)
		);

		LyLeaderBoard.oldStar = 0;
	},
});

var LyLeaderBoard = vee.Class.extend({

	btnClose    : null,

	ccbInit : function () {
		vee.Utils.scheduleOnce(function () {
			this.playChangeAnim();
		}.bind(this), 0.5);
	},

	playChangeAnim : function () {
		if (LyLeaderBoard.curIndex > LyLeaderBoard.newIndex) {
			var cellSelf = LyLeaderBoard.Cells[LyLeaderBoard.curIndex].rootNode;
			var cellNew = LyLeaderBoard.Cells[LyLeaderBoard.newIndex].rootNode;

			cellSelf.runAction(
				cc.EaseExponentialOut.create(
					cc.moveTo(1, cellNew.getPosition())
				)
			);

			cellNew.runAction(
				cc.EaseExponentialOut.create(
					cc.moveTo(1, cellSelf.getPosition())
				)
			);

			vee.Utils.scheduleOnce(function () {
				this.playChangeAnimEnd();
			}.bind(this), 0.8);
		}
		else {
			if (LyLeaderBoard.oldStar != 0) {
				var starNum = game.LevelData.getStar();
				LyLeaderBoard.Cells[LyLeaderBoard.curIndex].refreshStar(starNum);
			}
		}
	},

	playChangeAnimEnd : function() {
		var cellSelf = LyLeaderBoard.Cells[LyLeaderBoard.curIndex];
		cellSelf.refreshLeader(LyLeaderBoard.newIndex);

		var cellNew = LyLeaderBoard.Cells[LyLeaderBoard.newIndex];
		cellNew.refreshLeader(LyLeaderBoard.curIndex);

		LyLeaderBoard.curIndex = LyLeaderBoard.newIndex;
	},

	onClose : function () {
		if (this.isOver) return;
		this.isOver = true;
		this.playAnimate("hide", function () {
			vee.PopMgr.closeLayerByCtl(this);
			LyLevelSelect.nWindow = 0;
		}.bind(this));
	}
});

LyLeaderBoard.show = function () {
	if (LyLevelSelect.nWindow > 1)
		return;

	var node = vee.PopMgr.popCCB(res.ly_Leader_Board, { alpha : 0 });
	node.controller.ccbInit();

	LyLevelSelect.nWindow = 1;
};

LyLeaderBoard.checkUpdate = function() {
	var star = game.LevelData.getStar();
	for (var i = 1; i < LyLeaderBoard.curIndex; i++) {
		if (game.LeaderData.LeaderDetail[i].starNum <= star) {
			LyLeaderBoard.newIndex = i;
			return true;
		}
	}
	var lStar = vee.data["last_star"];
	if (!lStar) {
		vee.data["last_star"] = 0;
	}
	if (parseInt(lStar) < star){
		LyLeaderBoard.oldStar = lStar;
		vee.data["last_star"] = star;
		return true;
	}

	return false;
};

LyLeaderBoard.newIndex = 10;
LyLeaderBoard.curIndex = 10;
LyLeaderBoard.oldStar = 0;
LyLeaderBoard.Cells = {};


game.LeaderData = {
	LeaderDetail : [
		{ idx : 0, 	picName : "",					    	starNum : "", 	desc : '--',    price : 100,	},
		{ idx : 1, 	picName : res.hero_head_3_flash_png,	starNum : 200, 	desc : "电眼",	price : 100,	},
		{ idx : 2, 	picName : res.hero_head_12_m_png,		starNum : 195, 	desc : "小明", 	price : 300,	},
		{ idx : 3, 	picName : res.hero_head_7_vampire_png,	starNum : 178, 	desc : "伯爵",	price : 300,	},
		{ idx : 4, 	picName : res.hero_head_9_bear_png,		starNum : 147, 	desc : "熊熊",	price : 500,	},
		{ idx : 5, 	picName : res.hero_head_5_space_png,	starNum : 105, 	desc : "太空",	price : 800,	},
		{ idx : 6, 	picName : res.hero_head_4_cap_png,		starNum : 62, 	desc : "警察",  price : 1000,	},
		{ idx : 7, 	picName : res.hero_head_10_tiny_png,	starNum : 31, 	desc : "小小",  price : 1500,	},
		{ idx : 8, 	picName : res.hero_head_6_girl_png,		starNum : 14, 	desc : "月月",  price : 600,	},
		{ idx : 9, 	picName : res.hero_head_2_kevo_png,		starNum : 7, 	desc : "科沃",  price : 1000,	},
		{ idx : 10,	picName : res.hero_head_1_cat_png,		starNum : 5, 	desc : "小白",  price : 200,	},
	],
};