/**
 * Created with AppCode.
 * User: Yop Chan
 * Date: 14-3-19
 * Time: 下午4:35
 * To change this template use File | Settings | File Templates.
 */

var vee = vee = vee || {};

vee.IAPMgr = {

	iapPlugin : null,

    activate: function(){
        if (!this.iapPlugin){
            var pluginName = app.Config.IAPPluginName;
            this.iapPlugin = plugin.PluginManager.getInstance().loadPlugin(pluginName);
            if (this.iapPlugin && app.Config.IAPConfig){
				if (app.Config.IAPConfig) {
					var developerInfos;
					if (app.Config.IAPs) {
						var iapid = app.Config.IAPConfig.IAPID ? app.Config.IAPConfig.IAPID : "";
						var productIDs = "";
						var len = app.Config.IAPs.length;
						for (var i = 0; i < len; ++i) {
							productIDs += app.Config.IAPs[i].ProductID;
							if (i != len - 1) {
								productIDs += ",";
							}
						}
						developerInfos = {
							IAPID : iapid,
							ProductIDs : productIDs
						};
					} else {
						developerInfos = app.Config.IAPConfig;
					}
					this.iapPlugin.configDeveloperInfo(developerInfos);
					this.iapPlugin.setListener({
						successCallback : null,
						failCallback : null,
						cheatCallback : null,
						_isPurchasing : true,
						onPayResult : function(code, price){
							if(code == plugin.ProtocolIAP.PayResultCode.PaySuccess)
							{
								var arrPrices = price.split(",");
								vee.configIAPPrices(arrPrices);
							}
						}
					});
					var debug = vee.Utils.isDebugMode();
					this.iapPlugin.setDebugMode(debug);
				}
				else {   // added by yzl
					this.iapPlugin.configDeveloperInfo(null);
					var debug = vee.Utils.isDebugMode();
					this.iapPlugin.setDebugMode(debug);
				}
            }

            if (!this.iapPlugin) {
                this.iapPlugin = null;
            }
        }
    },

	/** @private */
	_purchase : function(info, successCallback, failCallback, cheatCallback) {
        this.activate();
		if (!this.iapPlugin) {
            cc.log("无法找到 plugin");
            if (failCallback){
                failCallback("Loading Purchase Function Error!");
            } else {
                vee.PopMgr.alert("Loading Purchase Function Error!", "PURCHASE FAIL");
            }
            return;
		}

        var listener = {
			successCallback : successCallback,
            failCallback : failCallback,
			cheatCallback : cheatCallback,
			_isPurchasing : true,
			onPayResult : function(code, msg){
				cc.log("result!!!!");
				if (this._isPurchasing){
					vee.PopMgr.closeLayer();
					this._isPurchasing = false;
				}
				if (code == plugin.ProtocolIAP.PayResultCode.PaySuccess) {
					cc.log("plugin.ProtocolIAP.PayResultCode.PaySuccess");
					this.successCallback(msg);
				} else if (code == plugin.ProtocolIAP.PayResultCode.PayCheat) {
					vee.Utils.scheduleBack(function () {
						if (this.cheatCallback) this.cheatCallback(msg);
						else cc.log("this.cheatCallback is undefined");
					}.bind(this));
				} else if (this.failCallback){
                    vee.Utils.scheduleBack(function() {
                        this.failCallback(msg);
                    }.bind(this));
                } else {
					cc.log("payresult");
                    vee.Utils.scheduleBack(function() {
                        vee.PopMgr.alert(msg, "PURCHASE FAIL");
                    }.bind(this));
				}
			}
		};
		this.iapPlugin.iapListener = listener;
		this.iapPlugin.setListener(this.iapPlugin.iapListener);
		vee.PopMgr.popLoading();
        this.iapPlugin.payForProduct(info);
	},

	_curIdx : 0,
	_curProductInfo : null,
	_successCB : null,
	_failCB : null,
	_cheatCB : null,
	/**
	 *
	 * @param {Number}   idx
	 * @param {Function} successCallback
     * @param {Function} failCallback
	 */
	buyProduct : function(idx, successCallback, failCallback, cheatCallback) {
		// added by yzl
		if (idx > 4) {
			if (game.ItemData.getItemPurchased(idx)) return;  // item after 4 can only buy once
		}
		// added by yzl end
		var productInfo = app.Config.IAPs[idx];
		if (idx == 0) {   // showGameBoard
			this._purchase(productInfo, successCallback, failCallback, cheatCallback);
			return;
		}

		this._successCB = successCallback;
		this._failCB = failCallback;
		this._cheatCB = cheatCallback;
		this._curIdx = idx;
		this._curProductInfo = productInfo;

		this.doBuyProduct();

		//LyPurchaseChoose.show();
	},

	doBuyProduct : function() {
		this._purchase(this._curProductInfo, this.purchaseSuccess, this._failCB, this._cheatCB);

		var orderID = new Date().getTime();
		game.Data.orderId = orderID;
		var itemID = this.getCurProductID();
		var price = this.getCurProductPrice();
		vee.Analytics.logChargeRequest(""+orderID, ""+itemID, price, "RMB", price, "Mi");
	},

	purchaseSuccess : function() {
		LyTips.show();

		vee.Analytics.logChargeSuccess(""+game.Data.orderId);

		if (vee.IAPMgr._successCB) {
			vee.IAPMgr._successCB();
		}
	},

	getCurProductID : function() {
		if (!this._curProductInfo)
			return null;

		return this._curProductInfo.ProductCode;
	},

	getCurProductPrice : function() {
		if (!this._curIdx || this._curIdx <= 0)
			return null;

		return game.ItemData.ItemDetail[this._curIdx].price;
	},

    /**
     * Alipay use this since there's no product id.
     * @param {Function} successCallback
     * @param {Function} failCallback
     */
    buyProductWithCustomParams: function(params, successCallback, failCallback){
        this._purchase(params, successCallback, failCallback);
    },

	restoreProduct : function(successCallback, failCallback) {
		this._purchase({
			ProductID : "Restore"
		}, successCallback, failCallback);
	},

	// WeiXin funcs...
	WeiXinLogin : function (isQR) {
		this.iapPlugin.callFuncWithParam("WXLogin",
			new plugin.PluginParam(plugin.PluginParam.ParamType.TypeStringMap, {
				isQR : ''+isQR
			})
		);
	},

	QQLogin : function () {
		this.iapPlugin.callFuncWithParam("QQLogin",
			new plugin.PluginParam(plugin.PluginParam.ParamType.TypeStringMap, {})
		);
	}
};

var VeeRestorePurchaseButton = vee.Class.extend({
	/** @expose */
	btnRestore : null,
	onCreate : function() {
		cc.log("purchaseButton\t" + cc.sys.os);
		var shouldShowBtn = false;
		for (var i = 0; i < app.Config.IAPs.length; ++i) {
			var nonConsumable = app.Config.IAPs[i].NonConsumable;
			if (nonConsumable == "true") {
				shouldShowBtn = true;
				break;
			}
		}
		this.rootNode.setVisible(shouldShowBtn);
		this.btnRestore.setEnabled(shouldShowBtn);
	},

	onRestore : function() {
		vee.IAPMgr.restoreProduct(VeeRestorePurchaseButton.callback);
		vee.Audio.onEvent("button");
	}
});
cc.BuilderReader.registerController("VeeRestorePurchaseButton", VeeRestorePurchaseButton);

VeeRestorePurchaseButton.registerCallback = function(callback){
	VeeRestorePurchaseButton._callback = callback;
}

/**
 * @param {String} productID
 */
VeeRestorePurchaseButton.callback = function(productID) {
	if (productID == app.Config.IAPs[0].ProductID) {
//		vee.Ad.banAd();
		vee.PopMgr.alert("Purchase success, AD's been remvoed.", "Success");
		if (VeeRemoveAdButton.shared) {
			VeeRemoveAdButton.shared.update();
		}
	}
	if (VeeRestorePurchaseButton._callback) {
		VeeRestorePurchaseButton._callback(productID);
	}
};

var VeeRemoveAdButton = vee.Class.extend({
	/** @expose */
	btnRemoveAd : null,
	onCreate : function() {
		VeeRemoveAdButton.shared = this;
		this.update();
	},

	onExit : function() {
		VeeRemoveAdButton.shared = null;
	},

	update : function() {
		if (!vee.data.adEnabled) {
			this.rootNode.setVisible(false);
			this.btnRemoveAd.setEnabled(false);
		}
	},

	/** @expose */
	onRemoveAd : function() {
		vee.IAPMgr.buyProduct(0, function(){
//			vee.Ad.banAd();
			this.rootNode.setVisible(false);
			this.btnRemoveAd.setEnabled(false);
			vee.PopMgr.alert("Purchase success, AD's been remvoed.", "Success");
		}.bind(this));
		vee.Audio.onEvent("button");
	}
});
cc.BuilderReader.registerController("VeeRemoveAdButton", VeeRemoveAdButton);

/** @type {VeeRemoveAdButton} */
VeeRemoveAdButton.shared = null;




var LyPurchaseChoose = vee.Class.extend({
	btnMI : null,
	btnWX : null,

	ccbInit : function () {
		this.handleKey(true);
	},

	onKeyBack : function () {
		this.onClose();
		return true;
	},

	onClose : function () {
		if (this.isOver) return;
		this.isOver = true;
		this.playAnimate("hide", function () {
			this.isOver = false;
			vee.PopMgr.closeLayerByCtl(this);
		}.bind(this));
	},


	onBtnMI : function() {
		vee.IAPMgr._curProductInfo.IsWX = null;
		vee.IAPMgr.doBuyProduct();
		this.onClose();
	},

	onBtnWX : function() {
		vee.IAPMgr._curProductInfo.IsWX = "1";
		vee.IAPMgr.doBuyProduct();
		this.onClose();
	},

});


LyPurchaseChoose.show = function () {
	vee.PopMgr.popCCB(res.purchase_ccbi, {alpha: 0});
	//var lyPurchaseChoose = vee.PopMgr.popCCB(res.purchase_ccbi, {alpha: 0});
};

